controllers/LibrosController.php
<?php

namespace app\controllers;
use app\models\Escritores;
use app\models\Generos;
use app\models\Escribir;
use app\models\Estanterias;
use app\models\Agregar;
use app\models\Libros;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\web\Response;
use yii;
/**
 * LibrosController implements the CRUD actions for Libros model.
 */
class LibrosController extends Controller
{
    
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Libros models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Libros::find(),
            
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'titulo' => SORT_ASC,
                ]
            ],
            
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Libros model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Libros model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    
public function actionCreate()
{
    $model = new Libros();
    $generos = Generos::find()->orderBy('genero')->all();

    
    $$model->paginas_leidas=0;
$generosSeleccionados = [];
    if ($model->load(Yii::$app->request->post()) && $model->save()) {
        // Obtener el ID recién creado del libro
        $id = $model->getPrimaryKey();
        
        // Crear una nueva instancia de la clase "Escribir"
        $escribir = new Escribir();
        $escribir->cod_libro = $id;
        $escribir->cod_escritor = Yii::$app->request->post('Libros')['cod_escritor'];
        $escribir->save();

        // Obtener los géneros seleccionados
        
        $generos = Yii::$app->request->post('Libros')['generos'];
        foreach ($generos as $genero) {
            $libroGenero = new Generos();
            $libroGenero->cod_libro = $id;
            $libroGenero->genero = $genero;
            $libroGenero->save();
        }
        return $this->redirect(['view', 'id' => $model->id]);
    }

    // Consultar los géneros y pasarlos a la vista
    $generosArray = ArrayHelper::map($generos, 'genero', 'genero');
    
    return $this->render('create', [
        'model' => $model,
        'generos' => $generosArray,
          'generosSeleccionados' => $generosSeleccionados,
    ]);
}




    /**
     * Updates an existing Libros model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
public function actionUpdate($id)
{
    $model = $this->findModel($id);

    // Obtener el autor actual del libro
    $autores = $model->codEscritors;
    $autorActual = null;
    if (!empty($autores)) {
        // Obtener el primer autor (pueden haber múltiples autores)
        $autorActual = $autores[0]->id;
    }

    // Obtener los géneros disponibles
    $generos = Generos::find()->distinct()->orderBy('genero')->all();

    // Obtener los géneros seleccionados
   $generosSeleccionados = isset($model->generos) ? ArrayHelper::getColumn($model->generos, 'id') : [];
   $generosActuales = ArrayHelper::getColumn($model->generos, 'genero');

    if ($model->load(Yii::$app->request->post()) && $model->save()) {
        // Actualizar la clave foránea en la tabla "escribir"
        $escribir = Escribir::findOne(['cod_libro' => $id]);

        if (!$escribir) {
            // Si no existe una entrada en la tabla "escribir", crear una nueva instancia
            $escribir = new Escribir();
            $escribir->cod_libro = $id;
        }

        // Asignar el código del autor proporcionado en el formulario de actualización
        $codEscritor = Yii::$app->request->post('Libros')['cod_escritor'];

        // Si el campo oculto "$autorActual" está presente, usar su valor en lugar del valor del campo "cod_escritor"
        $autorActual = Yii::$app->request->post('autorActual');
        if (isset($autorActual)) {
            $codEscritor = $autorActual;
        }

        // Asignar el código del autor al modelo "$model"
        $model->cod_escritor = $codEscritor;

        // Guardar los cambios en el modelo
        $model->save();

        // Actualizar la entrada en la tabla "escribir"
        $escribir->cod_escritor = $codEscritor;
        $escribir->save();

        // Eliminar los géneros anteriores del libro
       // Generos::deleteAll(['cod_libro' => $id]);

        // Guardar los nuevos géneros
        $generos = Yii::$app->request->post('Libros')['generos'];

        foreach ($generos as $genero) {
            $librosGeneros = new Generos();
            $librosGeneros->cod_libro = $id;
            $librosGeneros->genero = $genero;
            $librosGeneros->save();
        }

        return $this->redirect(['view', 'id' => $model->id]);
    }

    // Obtener los géneros y pasarlos a la vista
    $generosArray = ArrayHelper::map($generos, 'genero', 'genero');

    // Agregar la propiedad "checked" a los géneros que ya están seleccionados


    return $this->render('update', [
        'model' => $model,
        'generos' => $generosArray,
        'generosSeleccionados' => $generosSeleccionados,
        'autorActual' => $autorActual, // Pasar el autor actual a la vista
        'generosActuales' => $generosActuales, // Pasar los géneros actuales a la vista
    ]);
}



public function actionActualizarpaginasleidas($id)
{
    Yii::$app->response->format = Response::FORMAT_JSON;

    $libro = Libros::findOne($id);
    if (!$libro) {
        throw new NotFoundHttpException('El libro no existe.');
    }

    if (Yii::$app->request->isPost) {
        $libro->paginas_leidas = Yii::$app->request->post('paginasLeidas');
        if ($libro->save()) {
            
             if ($libro->paginas_leidas == $libro->num_pag) {

                // Recuperar la instancia de Agregar correspondiente al libro
                $agregar = Agregar::find()->where(['cod_libro' => $id])->one();

                // Actualizar el atributo cod_estanteria
                $estanteria = Estanterias::find()->where(['nombre' => 'Leído'])->one();
                $agregar->cod_estanteria = $estanteria->id;
                
                //Actualizar fecha de lectura
                $libro->f_lectura= date("Y-m-d");
                 $libro->save();
                $agregar->save();
            }
            $porcentajeLeido =  round($libro->porcentaje_leido($libro->paginas_leidas));
           
            return [
                'success' => true,
                'porcentaje_leido' => $porcentajeLeido,
                'paginas_leidas' => $libro->paginas_leidas,
                'num_pag' => $libro->num_pag,];
        } else {
            throw new ServerErrorHttpException('Hubo un error al actualizar las páginas leídas.');
        }
    }

    throw new BadRequestHttpException('La solicitud debe ser de tipo POST.');
}





    /**
     * Deletes an existing Libros model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Libros model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Libros the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Libros::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\FormRegister;
use app\models\Users;
use app\models\Libros;
use app\models\Agregar;
use app\models\Estanterias;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\Html;
use yii\data\ActiveDataProvider;
use yii\web\JsonResponse;
use yii\web\JsExpression;
use yii\data\ArrayDataProvider;


class SiteController extends Controller
{
    
    
public function actionBuscar()
{
   
    $busqueda = Yii::$app->request->get('q');
    if (!$busqueda) {
        // Redirigir al usuario a la página de inicio o mostrar un mensaje de error
         return $this->goHome();
    }
$registros = Libros::find()
    ->joinWith('codEscritors')
    ->where(['like', 'titulo', $busqueda])
    ->orWhere(['like', 'escritores.nombre', $busqueda])
    ->all();

    
    return $this->render('resultado-busqueda', [
        'registros' => $registros,
        'busqueda' => $busqueda,
    ]);
}

// ...

public function actionBusquedaajax($q)
{
    $registros = Libros::find()
        ->joinWith('codEscritors')
        ->where(['like', 'titulo', $q])
        ->orWhere(['like', 'escritores.nombre', $q])
        ->all();

    return $this->asJson(['registros' => $registros]);
}



    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

     
    
    /**
     * Displays homepage.
     *
     * @return string
     */
public function actionIndex()
{
    // Obtener los datos de los libros para mostrarlos en la vista
    $dataProvider = new ActiveDataProvider([
        'query' => Libros::find(),
        'pagination' => [
            'pageSize' => 50, // número de elementos por página
    ],
    ]);

    // Obtener las estanterías para mostrarlas en la vista
     $estanterias = Estanterias::find()->all();
     $actual= Estanterias::find()->where('id=2')->all();

     //libros de lecturas actuales
     $estanteriaLeyendoActualmente = Estanterias::findOne(['nombre' => 'Leyendo actualmente']);
$estanteriaLeyendoActualmenteId = $estanteriaLeyendoActualmente->id;

$librosLeyendoActualmente = Libros::find()
    ->joinWith(['codEstanterias', 'codLector'])
    ->where(['estanterias.id' => $estanteriaLeyendoActualmenteId, 
        'users.id' => Yii::$app->user->identity->id])
    ->all();

    // Renderizar la vista y pasar los datos a la vista
    return $this->render('index', [
        'dataProvider' => $dataProvider,
        'estanterias' => $estanterias,
        'actual'=>$actual,
        'librosLeyendoActualmente'=>$librosLeyendoActualmente,
    ]);
}

public function actionEstanteria($id) {
    $estanteria = Estanterias::findOne($id);

    if ($estanteria !== null) {
        $this->view->title = 'Estanteria: ' . $estanteria->nombre;

        $libros = Libros::find()
            ->joinWith(['codEstanterias', 'codLector'])
            ->where([
                'estanterias.id' => $id,
                'users.id' => Yii::$app->user->identity->id
            ])
            ->all();

        $dataProvider = new ArrayDataProvider([
            'allModels' => $libros,
        ]);

        return $this->render('estanteria', [
            'dataProvider' => $dataProvider,
            'estanteria'=>$estanteria,
        ]);
    } else {
        throw new NotFoundHttpException('La página que buscas no existe.');
    }
}

public function actionEstanteriatotal() {
    $estanteria = Estanterias::find()->all();

    if ($estanteria !== null) {
         $this->view->title = 'Todos mis libros';

        $libros = Libros::find()
            ->joinWith(['codEstanterias', 'codLector'])
            ->where([
                'users.id' => Yii::$app->user->identity->id
            ])
            ->all();

        $dataProvider = new ArrayDataProvider([
            'allModels' => $libros,
        ]);

        return $this->render('estanteria', [
            'dataProvider' => $dataProvider,
            'estanteria'=>$estanteria,
        ]);
    } else {
        throw new NotFoundHttpException('La página que buscas no existe.');
    }
}

    
 
    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }
    
    

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    

 
  public function randKey($str='', $long=0)
    {
        $key = null;
        $str = str_split($str);
        $start = 0;
        $limit = count($str)-1;
        for($x=0; $x<$long; $x++)
        {
            $key .= $str[rand($start, $limit)];
        }
        return $key;
    }
  

 
 public function actionRegister()
 {
  //Creamos la instancia con el model de validación
  $model = new FormRegister;
   
  //Mostrará un mensaje en la vista cuando el usuario se haya registrado
  $msg = null;
   
  //Validación mediante ajax
  if ($model->load(Yii::$app->request->post()) && Yii::$app->request->isAjax)
        {
            Yii::$app->response->format = Response::FORMAT_JSON;
            return ActiveForm::validate($model);
        }
   
  //Validación cuando el formulario es enviado vía post
  //Esto sucede cuando la validación ajax se ha llevado a cabo correctamente
  //También previene por si el usuario tiene desactivado javascript y la
  //validación mediante ajax no puede ser llevada a cabo
  if ($model->load(Yii::$app->request->post()))
  {
   if($model->validate())
   {
    //Preparamos la consulta para guardar el usuario
    $table = new Users;
    $table->username = $model->username;
    $table->email = $model->email;
    $table->f_registro = date("Y-m-d");
    $table->biografia = $model->biografia;
    //Encriptamos el password
    $table->password = crypt($model->password, Yii::$app->params["salt"]);
    //Creamos una cookie para autenticar al usuario cuando decida recordar la sesión, esta misma
    //clave será utilizada para activar el usuario
    $table->authKey = $this->randKey("abcdef0123456789", 20);
    //Creamos un token de acceso único para el usuario
    $table->accessToken = $this->randKey("abcdef0123456789", 20);
     
    //Si el registro es guardado correctamente
    if ($table->insert())
    {     
     $model->username = null;
     $model->email = null;
     $model->password = null;
     $model->password_repeat = null;
     
     $msg = "Enhorabuena";
    }
    else
    {
     $msg = "Ha ocurrido un error al llevar a cabo tu registro";
    }
     
   }
   else
   {
    $model->getErrors();
   }
  }
  return $this->render('register', ['model' => $model]);
 }

 
 
 
}

views/site/_estante.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;

?>


<div class="col-sm-12">
           
                
             <?= Html::a(Html::img('@web/img/'.$model -> id.'.jpg', ['alt'=>'Portada', 'class'=>'book-cover']),['libros/view', 'id'=>$model -> id ] ) ?>
                
                 <h6 class="card-title"><?=$model -> titulo?></h6>
             
         
        </div>

views/site/_estanteria.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\data\ActiveDataProvider;
?>

views/site/_libro.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;

?>


<div class="col-sm-12">
            <div class="card minimo">
                
             <?= Html::a(Html::img('@web/img/'.$model -> id.'.jpg', ['alt'=>'Portada', 'class'=>'book-cover']),['libros/view', 'id'=>$model -> id ] ) ?>
                
                 <h6 class="card-title"><?=$model -> titulo?></h6>
             
            </div>
        </div>

views/site/about.php
<?php

/** @var yii\web\View $this */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h2><?= Html::encode($this->title) ?></h2>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h2><?= Html::encode($this->title) ?></h2>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/estanteria.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
use yii\grid\ActionColumn;
use yii\grid\GridView;


$this->params['breadcrumbs'][] = ['label' => 'Estanteria: ', 'url' => ['estanterias/index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);


?>

    <h2><?= Html::encode($this->title) ?></h2>
<?= GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        [
            'attribute' => 'id',
            'label' => 'Portada',
            'format' => 'raw',
            'value' => function ($model) {
                return Html::a(Html::img('@web/img/'.$model->id.'.jpg', ['alt'=>'Portada', 'class'=>'minibook-cover']),['libros/view', 'id'=>$model->id]);
            },
        ],
        [
    'attribute' => 'titulo',
    'label' => 'Título',
    'format' => 'raw', // Asegura que se interprete el HTML
    'value' => function ($model) {
        return Html::decode(Html::a($model->titulo, ['libros/view', 'id' => $model->id]));
    },
],

                [
    'attribute' => 'autor',
'label' => 'Autor',
'value' => function ($model) {
    $nombres = [];
    foreach ($model->codEscritors as $escritor) {
        $nombres[] = Html::a($escritor->nombre, ['escritores/view', 'id' => $escritor->id]);
    }
    return implode(', ', $nombres);
},
'format' => 'raw',


    ],
      [
            'attribute' => 'fecha',
            'label' => 'Fecha de lectura',
            'value' => function ($model) {
                return $model->f_lectura;
            },
        ],           
          [
            'attribute' => 'calificacion',
            'label' => 'Calificación',
            'value' => function ($model) {
                return $model->calificacion;
            },
        ],    
                    

    ],
]); ?>


<div class="jumbotron text-center bg-transparent">
   <?=   ListView::widget([
            'dataProvider' => $dataProvider,
           'itemView' => '_estante',
          'layout'=>"{items}",
       
        ]);
?>
    
  
    </div>

views/site/index.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
use  yii\widgets\LinkPager;

//$user_id = Yii::$app->user->identity->id;
$this->title = 'Book';
?>

         <?php  if (Yii::$app->user->isGuest) {?>
       <div class="col-12 justify-content-center">
        
    <div class="jumbotron text-center bg-transparent">
        
       
        <h1 class="display-4">Nuestros libros</h1>

      <?=   ListView::widget([
            'dataProvider' => $dataProvider,
          'pager' => [
        'firstPageLabel' => 'first',
        'lastPageLabel' => 'last',
        'prevPageLabel' => 'previous',
        'nextPageLabel' => 'next',
    ],
           'itemView' => '_libro',
            'layout'=>"\n{items}\n{pager}",
            
        ]);
?>
   
    </div>   </div>
        
  <?php }else{?> 
           <div class="row justify-content-evenly align-items-top ">
               
     <div class="col-3 sidebard"> 
 
        <h5 class="d-flex align-items-center  text-decoration-none border-bottom">Estanterías</h5>
        
              <div class="collapse show" id="home-collapse">
             
                       
                       <?= Html::a('Todos los libros', ['site/estanteriatotal']) ?> 

                    <?php foreach ($estanterias as $estanteria): ?>
                       <br>
              <?= Html::a($estanteria->nombre, ['site/estanteria', 'id' => $estanteria->id]) ?>

                                       
                    <?php endforeach; ?>
                
              </div>
       
        
        
        <h5 class="d-flex align-items-center link-dark text-decoration-none border-bottom">Lecturas actuales</h5>
        
    <div class="actual">
    <?php foreach ($librosLeyendoActualmente as $libro): ?>
        <div class="libro" data-libro-id="<?=$libro->id?>">
            <?= Html::img('@web/img/'.$libro->id.'.jpg', ['alt'=>'Portada', 'class'=>'leyendo-cover']) ?>
            <section>
                <h6><?= Html::a($libro->titulo, ['libros/view', 'id' => $libro->id]) ?></h6>
                <p>de <?= Html::a($libro->getCodEscritors()->one()->nombre, ['escritores/view', 'id' => $libro->getCodEscritors()->one()->id]) ?></p>
                <?php $porcentajeLeido = $libro->porcentaje_leido($libro->paginas_leidas); ?>

               <div class="progress" id="progresoLibro<?= $libro->id ?>">
 
    <div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" 
         style="width: <?= $porcentajeLeido ?>%" 
         aria-valuenow="<?= $libro->paginas_leidas ?>" aria-valuemin="0" aria-valuemax="<?= $libro->num_pag ?>">
         
    </div>
                  
</div>
<div id="texto-progreso<?= $libro->id ?>">
                        <?= $libro->paginas_leidas ?> / <?= $libro->num_pag ?> (<?= round($libro->porcentaje_leido($libro->paginas_leidas)) ?>%)
</div>



<!-- Botón que abre el modal -->
<?= Html::button('Actualizar', [
    'class' => 'btn btn-outline-secondary btn-sm',
    'data-toggle' => 'modal',
    'data-target' => '#actualizarModal' . $libro->id,
    
]) ?>


<!-- Modal correspondiente a cada libro -->
<div class="modal fade" id="actualizarModal<?= $libro->id ?>" tabindex="-1" role="dialog" 
     aria-labelledby="actualizarModalLabel<?= $libro->id ?>" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="actualizarModalLabel<?= $libro->id ?>">Actualizar páginas leídas de <?= $libro->titulo ?></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <?= Html::label('Páginas leídas') ?>
                    <?= Html::input('number', 'paginasLeidas', $libro->paginas_leidas, ['class' => 'form-control', 'id' => 'paginasLeidas' . $libro->id]) ?>
                </div>
                <button class="btn-actualizar" class="btn btn-outline-secondary btn-sm" data-toggle="modal" data-target="#actualizarModal<?= $libro->id ?>" data-id="<?= $libro->id ?>" data-paginas="<?= $libro->num_pag ?>">Actualizar</button>
            </div>
                    </div>
                </div>
            </div>
        </section>
    </div>

            <?php endforeach; ?>
        </div>


         <h5 class="d-flex align-items-center link-dark text-decoration-none border-bottom">Generos</h5>
  </div>
                <div class="col-1"> 
                </div>
    <div class="col-8 justify-content-center">
          <div class="jumbotron text-center bg-transparent">
        
       
        <h1 class="display-4">Nuestros libros</h1>

            <?=   ListView::widget([
                  'dataProvider' => $dataProvider,
                   'pager' => [
              
    'class' => \yii\bootstrap4\LinkPager::class,
        'firstPageLabel' => '«',
        'lastPageLabel' => '»,',
        'prevPageLabel' => '<',
        'nextPageLabel' => '>',
    ],
                 'itemView' => '_libro',
                  'layout'=>"\n{items}",

              ]);
            ?>

        </div>
     </div>
 </div>
           
     <?php }?> 

views/site/resultado-busqueda.php
<?php

/** @var yii\web\View $this */
use yii\helpers\Html;
use  yii\widgets\ListView;
$progress=70;
//$user_id = Yii::$app->user->identity->id;
$this->title = 'Búsqueda';
?>
    <div class="jumbotron text-center bg-transparent">

    <h2>Resultados de la búsqueda para "<?= Html::encode($busqueda) ?>"</h2>
  <div class="resultado-busqueda">
 
    
<?php foreach ($registros as $registro): ?>
<div class="col-sm-2">
            <div class="card minimo">
        <?= Html::a(Html::img('@web/img/'.$registro -> id.'.jpg', ['alt'=>'Portada', 'class'=>'book-cover']),['libros/view', 'id'=>$registro-> id ] ) ?>
        
        <h6><?= Html::a($registro->titulo, ['libros/view', 'id'=>$registro-> id ] ) ?> </h6>
        <?php if (!empty($registro->codEscritors)): ?>
            <?= Html::a($registro->codEscritors[0]->nombre, ['escritores/view', 'id' => $registro->codEscritors[0]->id]) ?>
        <?php else: ?>
            No se encontró el escritor
        <?php endif; ?>
   </div>
        </div>
<?php endforeach; ?>
 
</div>
</div>